#!/bin/bash
set -e

# Create user

cd /tmp
sudo -u postgres psql <<-EOSQL
CREATE USER <%= @db_user %> WITH NOSUPERUSER NOCREATEDB ENCRYPTED PASSWORD '<%= @db_pass %>';
CREATE DATABASE eventdb WITH OWNER intelmq ENCODING UTF8;
GRANT ALL PRIVILEGES ON DATABASE eventdb TO intelmq;
\c eventdb;
CREATE SCHEMA intelmq AUTHORIZATION intelmq;
EOSQL
sudo -u postgres psql <<-EOSQL
CREATE DATABASE contactdb WITH OWNER intelmq ENCODING UTF8;
GRANT ALL PRIVILEGES ON DATABASE contactdb TO intelmq;
\c contactdb;
CREATE SCHEMA intelmq AUTHORIZATION intelmq;
EOSQL

rm -f /opt/intelmq/install/eventdb-initdb.sql 
sudo -u intelmq /opt/intelmq/venv/bin/intelmq_psql_initdb -o /opt/intelmq/install/eventdb-initdb.sql
sudo -u intelmq psql eventdb -f /opt/intelmq/install/eventdb-initdb.sql

test -f /opt/intelmq/install/contactdb-initdb.sql && sudo -u intelmq psql contactdb -f /opt/intelmq/install/contactdb-initdb.sql
test -f /opt/intelmq/install/eventdb-notifications.sql && sudo -u intelmq psql eventdb -f /opt/intelmq/install/eventdb-notifications.sql

touch /opt/intelmq/.pgsql-installed
